diff --git a/src/backend/utils/init/postinit.c b/src/backend/utils/init/postinit.c
index 31d6a05426..31b33524ad 100644
--- a/src/backend/utils/init/postinit.c
+++ b/src/backend/utils/init/postinit.c
@@ -972,8 +972,8 @@ InitPostgres(const char *in_dbname, Oid dboid,
 			ereport(FATAL,
 					(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
 					 errmsg("permission denied to start WAL sender"),
-					 errdetail("Only roles with the %s attribute may start a WAL sender process.",
-							   "REPLICATION")));
+					 errdetail("The connection user \"%s\" requires the %s attribute.",
+							   username, "REPLICATION")));
 	}
 
 	/*
